# frozen_string_literal: true

module EvilEvents::Core
  # @api private
  # @since 0.1.0
  module Events
    require_relative 'events/serializers'
    require_relative 'events/serializers/base'
    require_relative 'events/serializers/base/generic_config'
    require_relative 'events/serializers/base/abstract_engine'
    require_relative 'events/serializers/base/data_transformer'
    require_relative 'events/serializers/base/event_serialization_state'
    require_relative 'events/serializers/base/abstract_factory'
    require_relative 'events/serializers/json'
    require_relative 'events/serializers/json/engines'
    require_relative 'events/serializers/json/engines/native'
    require_relative 'events/serializers/json/config'
    require_relative 'events/serializers/json/factory'
    require_relative 'events/serializers/json/packer'
    require_relative 'events/serializers/json/unpacker'
    require_relative 'events/serializers/hash'
    require_relative 'events/serializers/hash/engines'
    require_relative 'events/serializers/hash/engines/native'
    require_relative 'events/serializers/hash/config'
    require_relative 'events/serializers/hash/factory'
    require_relative 'events/serializers/hash/packer'
    require_relative 'events/serializers/hash/unpacker'
    require_relative 'events/serializers/xml'
    require_relative 'events/serializers/xml/engines'
    require_relative 'events/serializers/xml/config'
    require_relative 'events/serializers/xml/factory'
    require_relative 'events/serializers/xml/packer'
    require_relative 'events/serializers/xml/unpacker'
    require_relative 'events/serializers/message_pack'
    require_relative 'events/serializers/message_pack/engines'
    require_relative 'events/serializers/message_pack/config'
    require_relative 'events/serializers/message_pack/factory'
    require_relative 'events/serializers/message_pack/packer'
    require_relative 'events/serializers/message_pack/unpacker'
    require_relative 'events/event_extensions/type_aliasing'
    require_relative 'events/event_extensions/payloadable'
    require_relative 'events/event_extensions/payloadable/abstract_payload'
    require_relative 'events/event_extensions/manageable'
    require_relative 'events/event_extensions/dispatchable'
    require_relative 'events/event_extensions/observable'
    require_relative 'events/event_extensions/serializable'
    require_relative 'events/event_extensions/metadata_extendable'
    require_relative 'events/event_extensions/metadata_extendable/abstract_metadata'
    require_relative 'events/event_extensions/class_signature'
    require_relative 'events/event_extensions/class_signature/signature'
    require_relative 'events/event_extensions/class_signature/equalizer'
    require_relative 'events/event_extensions/hookable'
    require_relative 'events/event_extensions/hookable/abstract_hook'
    require_relative 'events/event_extensions/hookable/after_emit_hook'
    require_relative 'events/event_extensions/hookable/before_emit_hook'
    require_relative 'events/event_extensions/hookable/on_error_hook'
    require_relative 'events/notifier'
    require_relative 'events/notifier/logging'
    require_relative 'events/notifier/abstract'
    require_relative 'events/notifier/sequential'
    require_relative 'events/notifier/worker'
    require_relative 'events/notifier/worker/executor'
    require_relative 'events/notifier/worker/job'
    require_relative 'events/notifier/builder'
    require_relative 'events/notifier/proxy'
    require_relative 'events/abstract_event'
    require_relative 'events/manager'
    require_relative 'events/manager/subscriber_list'
    require_relative 'events/manager_factory'
    require_relative 'events/manager_registry'
    require_relative 'events/manager_registry/scoped_event_type_matcher'
    require_relative 'events/subscriber'
    require_relative 'events/subscriber/mixin'
    require_relative 'events/event_factory'
  end
end
